diff -pruN 20.4-1/ChangeLog 20.4.1-1/ChangeLog
--- 20.4-1/ChangeLog	2020-11-24 17:38:50.000000000 +0000
+++ 20.4.1-1/ChangeLog	2021-01-15 17:33:05.000000000 +0000
@@ -1,3 +1,6 @@
+20.4.1
+ - Revert "ssh_util: handle non-default AuthorizedKeysFile config (#586)"
+
 20.4
  - tox: avoid tox testenv subsvars for xenial support (#684)
  - Ensure proper root permissions in integration tests (#664) [James Falcon]
diff -pruN 20.4-1/cloudinit/ssh_util.py 20.4.1-1/cloudinit/ssh_util.py
--- 20.4-1/cloudinit/ssh_util.py	2020-11-24 17:38:50.000000000 +0000
+++ 20.4.1-1/cloudinit/ssh_util.py	2021-01-15 17:33:05.000000000 +0000
@@ -262,13 +262,13 @@ def extract_authorized_keys(username, ss
 
         except (IOError, OSError):
             # Give up and use a default key filename
-            auth_key_fns.append(default_authorizedkeys_file)
+            auth_key_fns[0] = default_authorizedkeys_file
             util.logexc(LOG, "Failed extracting 'AuthorizedKeysFile' in SSH "
                         "config from %r, using 'AuthorizedKeysFile' file "
                         "%r instead", DEF_SSHD_CFG, auth_key_fns[0])
 
-    # always store all the keys in the first file configured on sshd_config
-    return (auth_key_fns[0], parse_authorized_keys(auth_key_fns))
+    # always store all the keys in the user's private file
+    return (default_authorizedkeys_file, parse_authorized_keys(auth_key_fns))
 
 
 def setup_user_keys(keys, username, options=None):
diff -pruN 20.4-1/cloudinit/version.py 20.4.1-1/cloudinit/version.py
--- 20.4-1/cloudinit/version.py	2020-11-24 17:38:50.000000000 +0000
+++ 20.4.1-1/cloudinit/version.py	2021-01-15 17:33:05.000000000 +0000
@@ -4,7 +4,7 @@
 #
 # This file is part of cloud-init. See LICENSE file for license information.
 
-__VERSION__ = "20.4"
+__VERSION__ = "20.4.1"
 _PACKAGED_VERSION = '@@PACKAGED_VERSION@@'
 
 FEATURES = [
diff -pruN 20.4-1/debian/changelog 20.4.1-1/debian/changelog
--- 20.4-1/debian/changelog	2020-11-26 03:29:14.000000000 +0000
+++ 20.4.1-1/debian/changelog	2021-01-19 18:27:39.000000000 +0000
@@ -1,3 +1,10 @@
+cloud-init (20.4.1-1) unstable; urgency=medium
+
+  * d/watch: switch upstream to github
+  * New upstream version 20.4.1
+
+ -- Noah Meyerhans <noahm@debian.org>  Tue, 19 Jan 2021 10:27:39 -0800
+
 cloud-init (20.4-1) unstable; urgency=medium
 
   * New upstream version 20.4
diff -pruN 20.4-1/tests/unittests/test_sshutil.py 20.4.1-1/tests/unittests/test_sshutil.py
--- 20.4-1/tests/unittests/test_sshutil.py	2020-11-24 17:38:50.000000000 +0000
+++ 20.4.1-1/tests/unittests/test_sshutil.py	2021-01-15 17:33:05.000000000 +0000
@@ -593,7 +593,7 @@ class TestMultipleSshAuthorizedKeysFile(
             fpw.pw_name, sshd_config)
         content = ssh_util.update_authorized_keys(auth_key_entries, [])
 
-        self.assertEqual(authorized_keys, auth_key_fn)
+        self.assertEqual("%s/.ssh/authorized_keys" % fpw.pw_dir, auth_key_fn)
         self.assertTrue(VALID_CONTENT['rsa'] in content)
         self.assertTrue(VALID_CONTENT['dsa'] in content)
 
@@ -610,7 +610,7 @@ class TestMultipleSshAuthorizedKeysFile(
         sshd_config = self.tmp_path('sshd_config')
         util.write_file(
             sshd_config,
-            "AuthorizedKeysFile %s %s" % (user_keys, authorized_keys)
+            "AuthorizedKeysFile %s %s" % (authorized_keys, user_keys)
         )
 
         (auth_key_fn, auth_key_entries) = ssh_util.extract_authorized_keys(
@@ -618,7 +618,7 @@ class TestMultipleSshAuthorizedKeysFile(
         )
         content = ssh_util.update_authorized_keys(auth_key_entries, [])
 
-        self.assertEqual(user_keys, auth_key_fn)
+        self.assertEqual("%s/.ssh/authorized_keys" % fpw.pw_dir, auth_key_fn)
         self.assertTrue(VALID_CONTENT['rsa'] in content)
         self.assertTrue(VALID_CONTENT['dsa'] in content)
 
